#!/usr/bin/env python3
"""
Skip To N
by Javantea
Dec 7, 2014
Skip to an offset found by find_compress1, magic1 or any other program.
For example:
skipto.py Lume 10501924 >Lume.swf
"""
from __future__ import print_function
import sys

SEEK_SET = 0

def skipTo(file_obj, offset):
	"""
	file_obj is a file object. It can be a StringIO. It can be binary or 
	text but you better know the difference. If it's a pipe, seek may not 
	work. We should test that.
	offset is a number that you want to skip to.
	Returns the data as either a string or a bytes depending on which type 
	the file is giving us.
	This function is simple enough for you to write into your code, don't 
	call it as a library because that's just weird.
	"""
	file_obj.seek(offset, SEEK_SET)
	return file_obj.read()
#end def skipTo(file_obj, offset)

def usage():
	"""Usage:
	skipto.py filename offset >out_filename
	filename should be your input file.
	offset is the position in decimal.
	out_filename is the file you wish to create.
	"""
	print(usage.__doc__)
#end def usage()

def main():
	if '-h' in sys.argv:
		usage()
		return 1
	#end if
	if len(sys.argv) < 2:
		usage()
		return 1
	#end if
	filename = sys.argv[1]
	offset = 0
	if len(sys.argv) > 2:
		offset = int(sys.argv[2])
	#end if

	binfile = open(filename, 'rb')
	b = skipTo(binfile, offset)
	if sys.hexversion >= 0x3000000:
		try:
			sys.stdout.buffer.write(b)
		except BrokenPipeError:
			# Not even sure what the deal is with this...
			pass
		#end try
	else:
		sys.stdout.write(b)
	#end if
#end def main()

if __name__ == '__main__':
	main()
#end if

